//"mixzalu.sc","Mix-soft Zalogowani uzytkownicy",12010,0,1.0.6,SYSTEM
//"Pomocnicze",12001,14,16

// typy kolumn
#define ftString	0	
#define ftInt   	1	
#define ftLong   	16
#define ftMoney   	2
#define ftDate   	3
#define ftBitmap   	17
#define ftCheck   	7

// kolumny
#define COL_LP   		0
#define COL_USER	   	1
#define COL_NAZWA	   	2
#define COL_STACJA	   	3
#define COL_CZAS	   	4

dispatch dGrid

//------------------------------------------------------------------
int Sub AddColumn(dispatch g, string ColName, int ColWidth, int ColType, int ColLen, int ColHidden, int ColLocked)
//------------------------------------------------------------------
	int col

    G.ColumnCount = G.ColumnCount + 1
    col = G.ColumnCount - 1
    G.Columns(col).Name 		= ColName
    G.Columns(col).Width 		= ColWidth
    G.Columns(col).FieldType(ColType, ColLen)
    G.Columns(col).hidden 		= ColHidden
    G.Columns(col).Locked 		= ColLocked

endsub

//-------------------------------------------------------------------------
string Sub NazwaUzytkownika( string sSygnatura ) 
//-------------------------------------------------------------------------    
   baseKH kh 
   kh.SetKey("kod") 
   kh.SetKeySeg("typi", 103) 
   kh.SetKeySeg("kod", sSygnatura) 

   kh.GetRec(EQ) 
   NazwaUzytkownika = kh.GetField("nazwa") 

endsub 

//------------------------------------------------------------------
string sub DateTimeFromLong(long lDateTime)
//------------------------------------------------------------------
date DataOd 
long lIle, lIleDni,lIleSekund
DataOd.FromStr("1980-01-01") // = 315529200

		lIleDni = ((lDateTime - 315529200)/(24*60*60))
		lIleSekund = (lDateTime - 315529200 - (lIleDni*24*60*60))
		DataOd.AddDays(lIleDni)
		DateTimeFromLong = using "%s %l:%l",DataOd.ToStr(), lIleSekund/(60*60),(lIleSekund - ((lIleSekund/(60*60))*60*60))/60

endsub

//------------------------------------------------------------------
int sub WczytajZalogowanych()
//------------------------------------------------------------------	
string sPlik
dispatch dRow
int iPoz

		dGrid.RowCount = 0

sPlik = find file ( KatalogFirmy() + "*.slck" )
while sPlik

	buf = sPlik
	if find regular "^{*}.{*}.{*}.{*}.{*}$" then
		dRow = dGrid.InsertRow(-1)
		dRow.Value(COL_LP) = iPoz+=1
		dRow.Value(COL_STACJA) = regular 2
		dRow.Value(COL_USER) = regular 3
		dRow.Value(COL_CZAS) = DateTimeFromLong(Val(regular 4))
		dRow.Value(COL_NAZWA) = NazwaUzytkownika(regular 3)

	endif
	sPlik = find next file
wend

endsub

//------------------------------------------------------------------
int sub OnCommandRen(int id, int msg)
//------------------------------------------------------------------	
	
	if id == 0 && msg == 0 then
		dGrid.ColumnCount = 0
		dGrid.RowHeader = 0
		AddColumn(dGrid, "Lp", 30, ftLong,0, 0, 1)
		AddColumn(dGrid, "Sygnatura", 150, ftString,100, 0, 1)
		AddColumn(dGrid, "Nazwa", 150, ftString,200, 0, 1)	
		AddColumn(dGrid, "Stacja", 100, ftString,200, 0, 1)	
		AddColumn(dGrid, "Czas logowania", 150, ftString,100, 0, 1)	

			dgrid.Template.SetFont(0, "Arial", 12, 1)
			dgrid.Template.SetFont(1, "Arial", 12, 0)
			dgrid.Template.SetFont(-1, "Arial", 12, 1)

		dGrid.Footer.RowCount = 1
		WczytajZalogowanych()

	endif

endsub

//------------------------------------------------------------------
int sub PokazFormeLog()
//------------------------------------------------------------------	

	FORM "Mix-soft Zalogowani uytkownicy",600,270

		CONTROL "grid", dGrid, 5,5, 585,200
		BUTTON "Zamknij", 5,215,80,25, -1
		BUTTON "Odwie", 90,215,80,25, WczytajZalogowanych()

	int rv = ExecForm OnCommandRen	

endsub

PokazFormeLog()

error ""